import os
import sys

#class_.add_registration_code('def("__setitem__", &MyPArray<%s>::setItem)' % containedType)

from pyplusplus import module_builder
from pygccxml import declarations
from pyplusplus.module_builder import call_policies

def getPythonIncludes():
    f=os.popen('python-config --includes','r')
    line=f.readline();
    f.close()

    incs=line.strip().split(' ')
    return [inc.replace('-I','') for inc in incs]

pyincs=getPythonIncludes()

mb = module_builder.module_builder_t(
    files=['mat3x3.h',
	   'vec2.h',
	   'vec3.h',
	   'vec4.h',
	   'quaternion.h',
	   'mat4x4.h','matrix.h'],
    include_paths=['.']+pyincs,
    define_symbols=['VEC2_INSTANTIATE','VEC3_INSTANTIATE','VEC4_INSTANTIATE','__PY_PLUS_PLUS']
    ) #path to gccxml executable


# Allow tuple item setting and getting here
psets = mb.classes()
for p in psets:
    if p.member_functions(name='python_set',allow_empty=True):
	p.add_registration_code('def("__setitem__",&%s::python_set)'%p.decl_string)

#I want to exclude all functions that returns pointer to int
ptr = mb.member_functions( return_type='double *' )
for p in ptr:
    p.call_policies=call_policies.return_value_policy(call_policies.return_by_value)
#ptr_to_int.exclude()

ptr = mb.member_functions( return_type='float *' )
for p in ptr:
    p.call_policies=call_policies.return_value_policy(call_policies.return_by_value)
#ptr_to_int.exclude()

ptr_to_int = mb.member_operators( return_type='double &')
for p in ptr_to_int:
    p.call_policies=call_policies.return_value_policy(call_policies.copy_non_const_reference)
#ptr_to_int.exclude()

mb.build_code_creator( module_name='nmath' )
mb.write_module( os.path.join( os.path.abspath('.'),'py_nmath.cc'))

