#include <matrix.h>
#include <mat3x3.h>
using namespace nacb;

double testConst(const Mat3x3 & m){
  double a = m(0,0)+m[0];
  return a;
}

int main(int ac,char * av[]){
  Matrix A=Matrix::random(10,10);
  Matrix vec,val;
  Mat3x3 m33;

  testConst(m33);

  A=A*A.transpose();
  A.eigSym(vec,val);
  A.printMatlab("A");

  (vec*vec.transpose()).printMatlab("vec.*vec'");
  vec.printMatlab("vec");
  val.printMatlab("val");

  Matrix D=A-vec*Matrix::diag(val)*vec.transpose();
  printf("RMS: %e\n",sqrt(D.dot(D)/(D.m*D.n)));
  
  return 0;
}
